django_project/urls.py
from django.conf import settings
from django.urls import path
from django.urls import include
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.views.generic import TemplateView
from django.conf.urls.static import static

urlpatterns = [
    path("admin/", admin.site.urls),
    path(
        "",
        TemplateView.as_view(template_name="home.html"),
        name="home",
    ),
    path(
        "team/",
        TemplateView.as_view(template_name="team.html"),
        name="team",
    ),
    path(
        "about/",
        TemplateView.as_view(template_name="about.html"),
        name="about",
    ),
    path("accounts/", include("users.urls")),
    path("accounts/", include("user_profile.urls")),
]

urlpatterns += [
    path(
        "accounts/password_change/",
        auth_views.PasswordChangeView.as_view(
            template_name="registration/password_change.html",
        ),
        name="password_change",
    ),
    path(
        "accounts/password_change/done/",
        auth_views.PasswordChangeDoneView.as_view(
            template_name="registration/password_change_done.html",
        ),
        name="password_change_done",
    ),
    path(
        "accounts/login/",
        auth_views.LoginView.as_view(
            template_name="registration/login.html",
        ),
        name="login",
    ),
    path(
        "accounts/logout/",
        auth_views.LogoutView.as_view(
            template_name="registration/logout.html",
        ),
        name="logout",
    ),
    path(
        "accounts/password_reset/",
        auth_views.PasswordResetView.as_view(
            template_name="registration/password_reset.html",
        ),
        name="password_reset",
    ),
    path(
        "accounts/password_reset/done/",
        auth_views.PasswordResetDoneView.as_view(
            template_name="registration/password_reset_done.html",
        ),
        name="password_reset_done",
    ),
    path(
        "accounts/reset/<uidb64>/<token>/",
        auth_views.PasswordResetConfirmView.as_view(
            template_name="registration/password_reset_confirm.html",
        ),
        name="password_reset_confirm",
    ),
    path(
        "accounts/reset/done/",
        auth_views.PasswordResetCompleteView.as_view(
            template_name="registration/password_reset_complete.html",
        ),
        name="password_reset_complete",
    ),
]

urlpatterns += static(
    settings.STATIC_URL,
    document_root=settings.STATIC_ROOT,
)
urlpatterns += static(
    settings.MEDIA_URL,
    document_root=settings.MEDIA_ROOT,
)

user_profile/urls.py
"""User profile app URL."""

from django.urls import path

from . import views

app_name = "user_profile"

urlpatterns = [
    path(
        "profile/",
        views.UserProfileDetailView.as_view(),
        name="profile_detail",
    ),
    path(
        "profile/update/",
        views.UserProfileUpdateView.as_view(),
        name="profile_update",
    ),
]

users/urls.py
"""Accounts app URL Configuration."""

from django.urls import path

from users import views as users_views

app_name = "users"

urlpatterns = [
    path(
        "signup/",
        users_views.SignUpView.as_view(),
        name="signup",
    ),
]

user_profile/models.py
"""User profile app models."""

from django.db import models
from django.dispatch import receiver
from django.db.models.signals import post_save

from users.models import CustomUser


class UserProfile(models.Model):
    """UserProfile model class."""

    class Gender(models.IntegerChoices):
        """Gender choice class."""

        NONE = 0
        FEMALE = 1
        MALE = 2
        OTHER = 3

    custom_user = models.OneToOneField("users.CustomUser", on_delete=models.CASCADE)
    gender = models.IntegerField(choices=Gender.choices, default=Gender.NONE)
    age = models.IntegerField(default=21)
    picture = models.ImageField(upload_to="profile_pictures/", blank=True)


@receiver(post_save, sender=CustomUser)
def create_profile(sender, instance, created, **kwargs):
    """Create an object of UserProfile when a user CustomUser object is created."""
    if sender and created:
        UserProfile.objects.create(custom_user=instance)


post_save.connect(create_profile, sender=CustomUser)

user_profile/forms.py
"""User Profile Forms."""

from django import forms

from . import models


class UserProfileUpdateForm(forms.ModelForm):
    """User profile change view."""

    first_name = forms.CharField(max_length=32)
    last_name = forms.CharField(max_length=32)

    class Meta:
        """Meta class."""

        model = models.UserProfile
        fields = [
            "first_name",
            "last_name",
            "gender",
            "age",
            "picture",
        ]

user_profile/views.py
"""User profile view."""

from django.urls import reverse_lazy
from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin

from . import forms
from . import models

STUDENT, TEACHER = 1, 2


# Create your views here.
class UserProfileDetailView(LoginRequiredMixin, generic.DetailView):
    """Profile detail view.

    Reason why `slug_field` and `slug_url_kwargs` are set as `None`:
    - By default, in a `DetailView`, the object of the model is retrieved from the URL parameters.
    - In this case, as the model is `UserProfile`, the object of user is retrieved from the request.

    """

    model = models.UserProfile
    template_name = "user_profile/userprofile_detail.html"
    slug_field = None
    slug_url_kwarg = ""

    def get_object(self, queryset: list = None):
        """Owner of the object should be the current user."""
        return self.model.objects.filter(custom_user=self.request.user).first()


class UserProfileUpdateView(LoginRequiredMixin, generic.UpdateView):
    """Profile update view."""

    model = models.UserProfile
    form_class = forms.UserProfileUpdateForm
    success_url = reverse_lazy("user_profile:profile_detail")
    template_name = "generic_create_update_form.html"
    extra_context = {"title_text": "Update Profile", "button_text": "Update"}

    def get_object(self, queryset: list = None):
        """Get the `UserProfile` object the current logged in user."""
        return self.model.objects.filter(custom_user=self.request.user).first()

    def get_context_data(self, **kwargs):
        """Add additional fields to the form.

        In addition to the age, gender, and picture fields of `UserProfile` object,
        add `first_name` and `last_name` fields of the `CustomUser` to the form.

        Hence, to the `form` to be rendered by Django template, add two fields:
        `fist_name` and `last_name`.

        """
        context = super().get_context_data(**kwargs)

        user_profile = self.request.user.userprofile

        initial = {
            "first_name": self.request.user.first_name,
            "last_name": self.request.user.last_name,
        }

        context["form"] = forms.UserProfileUpdateForm(
            instance=user_profile,
            initial=initial,
        )

        return context

    def form_valid(self, form: object):
        """Set custom_user Field of the current object as the current user.

        - Update the `first_name` and `last_name` fields of the `CustomUser` model.
        - Set the `custom_user` (ForeignKey) field of `UserProfile` object of current user.
        - Update `is_student` and `is_teacher`: they are mutually exclusive.
        - Save the changes made to objects of `user_profile` and `custom_user` objects to the DB.

        """
        user_profile = form.save(commit=False)
        user_profile.custom_user = self.request.user

        custom_user = self.request.user
        custom_user.first_name = form.cleaned_data["first_name"]
        custom_user.last_name = form.cleaned_data["last_name"]

        user_profile.save()
        custom_user.save()

        return super().form_valid(form)

user_profile/templates/user_profile/userprofile_detail.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% load static %}
{% block title %}
    User Profile
{% endblock title %}
{% block content %}
    <div class="row align-items-md-stretch py-4">
        <div class="col-md-5"></div>
        <div class="col-md-2">
            <div class="text-center">
                {% if user.userprofile.picture %}
                    <img src="{{ user.userprofile.picture.url }}"
                         alt="Profile Picture"
                         class="rounded-circle img-thumbnail"
                         height="auto"
                         width="auto">
                {% else %}
                    <img src="{% static 'img/user-icon.png' %}"
                         alt="Profile Picture"
                         class="rounded-circle img-thumbnail"
                         height="auto"
                         width="auto">
                {% endif %}
            </div>
        </div>
        <div class="col-md-5"></div>
    </div>
    <div class="row align-items-md-stretch py-4">
        <div class="col-md-4"></div>
        <div class="col-md-4">
            <ul>
                <li>First Name: {{ user.first_name }}</li>
                <li>Last Name: {{ user.last_name }}</li>
                <li>Age: {{ user.userprofile.age }}</li>
                <li>Gender: {{ user.userprofile.get_gender_display }}</li>
            </ul>
        </div>
        <div class="col-md-4"></div>
    </div>
    <div class="row align-items-md-stretch">
        <div class="col-md-4"></div>
        <div class="col-md-4">
            <a class="btn btn-primary"
               role="button"
               href="{% url 'user_profile:profile_update' %}">
                <i class="fa-solid fa-edit"></i> Update Profile
            </a>
            <a class="btn btn-warning"
               role="button"
               href="{% url 'password_change' %}">
                <i class="fa-solid fa-user-cog"></i> Change password
            </a>
        </div>
        <div class="col-md-4"></div>
    </div>
{% endblock content %}